<template>
    <div id="player">
        <div id="grid-carousel"></div>
        <div class="actions">
            <div>
                AUDIO
                <div @click="toggleAudio" :class="{'on': audioOn, 'off': !audioOn}">
                    {{ audioOn ? 'ON' : 'OFF' }}
                </div>
            </div>
            <div>
                VIDEO
                <div @click="toggleVideo" :class="{'on': videoOn, 'off': !videoOn}">
                    {{ videoOn ? 'ON' : 'OFF' }}
                </div>
            </div>
            <div>
                &nbsp;
                <div @click="finish">FINISH</div>
            </div>
        </div>
    </div>
</template>
<script>
    import generateToken from "@/helpers/Twilio";
    import {createLocalTracks, connect} from 'twilio-video'
    import faker from 'faker'
    
    export default {
        name: 'VideoPlayer',
        data() {
            return {
                audioOn: true,
                videoOn: true,
                room: null
            }
        },
        created() {
            this.connectToRoom().then(() => {
                this.createAndAttachLocalParticipant();
                this.setUpRoom();
            });
            
        },
        methods: {
            //---------->>>>>>>>>>>>>>>>>
            async connectToRoom() {
                //Generate name
                let fakeName = localStorage.getItem('participant_name');
                if (!fakeName) {
                    fakeName = faker.name.findName();
                    localStorage.setItem('participant_name', fakeName)
                }
                //Create token using our helpers
                const token = generateToken(fakeName);
                
                //Create localTracks
                //Red more info on twilio Doc
                const tracks = await createLocalTracks({
                    video: {width: 1280},
                    audio: true,
                    bandwidthProfile: {
                        video: {
                            mode: 'grid',
                            maxTracks: 2,
                            dominantSpeakerPriority: 'standard',
                            renderDimensions: {
                                high: {
                                    height: 1080,
                                    width: 1980,
                                },
                                standard: {
                                    height: 720,
                                    width: 1280,
                                },
                                low: {
                                    height: 176,
                                    width: 144,
                                },
                            },
                        },
                    },
                    dominantSpeaker: true,
                    maxAudioBitrate: 16000,
                    preferredVideoCodecs: [{
                        codec: 'VP8',
                        simulcast: true,
                    }],
                    networkQuality: {
                        local: 1,
                        remote: 1,
                    },
                });
                this.room = await connect(token, {
                    name: 'PI_SCHOOL_DEMO',
                    tracks
                });
            },
            //---------->>>>>>>>>>>>>>>>>
            setUpRoom() {
                // Go over all participants that already in room
                this.room.participants.forEach(participant => {
                    participant.tracks.forEach(publication => {
                        if (publication.track && publication.kind !== 'data') {
                            this.attachRemoteTrack(participant, publication.track)
                        }
                        
                        if (publication.isSubscribed) {
                            publication.track.on('disabled', (track) => {
                                this.setNoVideo(participant)
                            })
                            
                            publication.track.on('enabled', (track) => {
                                this.removeNoVideo(participant)
                            })
                        }
                        
                        publication.on('subscribed', (track) => {
                            track.on('disabled', (track) => {
                                this.setNoVideo(participant)
                            })
                            
                            track.on('enabled', (track) => {
                                this.removeNoVideo(participant)
                            })
                        })
                    })
                    
                    participant.on('trackSubscribed', (track) => {
                        if (track.kind !== 'data') {
                            this.attachRemoteTrack(participant, track)
                        }
                    })
                    
                })
                
                //Subscribe on new participant join\left room
                this.room.on('participantConnected', (participant) => {
                    participant.on('trackSubscribed', (track) => {
                        if (track.kind !== 'data') {
                            this.attachRemoteTrack(participant, track)
                        }
                    })
                })
                this.room.on('participantDisconnected', (participant) => {
                    this.remoteParticipantElement(participant).remove();
                })
                
                //Fires when we click finish
                //see finish method
                this.room.on('disconnected', (room) => {
                    room.localParticipant.tracks.forEach(publication => {
                        if (publication.kind !== 'data') {
                            publication.track.stop();
                            publication.unpublish();
                        }
                    })
                    this.remoteParticipantElement(room.localParticipant).remove()
                    window.location = 'https://school.postindustria.com/'
                })
                
            },
            
            //---------->>>>>>>>>>>>>>>>>
            //Function that create wrapper for and attach tracks for local participant
            createAndAttachLocalParticipant() {
                const {identity} = this.room.localParticipant
                const div = document.createElement('div');
                div.className = 'local-participant';
                div.setAttribute('data-participant-identity', identity);
                
                this.room.localParticipant.tracks.forEach(async publication => {
                    if (publication.kind !== 'data') {
                        div.appendChild(await publication.track.attach())
                    }
                });
                
                let nameDiv = document.createElement('span');
                nameDiv.className = 'name';
                nameDiv.innerText = identity
                
                div.appendChild(nameDiv)
                
                document.getElementById('grid-carousel').appendChild(div);
                
                
            },
            
            //---------->>>>>>>>>>>>>>>>>
            //Function that create wrapper or return existing
            remoteParticipantElement(participant) {
                const {identity} = participant;
                
                let div = document.querySelector(`[data-participant-identity="${identity}"]`)
                if (div) return div;
                
                div = document.createElement('div');
                div.className = 'remote-participant';
                div.setAttribute('data-participant-identity', identity);
                
                let nameDiv = document.createElement('span');
                nameDiv.className = 'name';
                nameDiv.innerText = identity
                
                div.appendChild(nameDiv)
                
                document.getElementById('grid-carousel').appendChild(div);
                return div;
                
            },
            //---------->>>>>>>>>>>>>>>>>
            //Attaching remote tracks
            async attachRemoteTrack(participant, track) {
                const el = this.remoteParticipantElement(participant);
                if (el.querySelector(track.kind)) el.querySelector(track.kind).remove()
                el.appendChild(await track.attach())
            },
            
            //---------->>>>>>>>>>>>>>>>>
            //Turn ON\OFF - local video
            toggleVideo() {
                this.videoOn = !this.videoOn;
                this.room.localParticipant.videoTracks.forEach(publication => {
                    if (this.videoOn) {
                        this.removeNoVideo(this.room.localParticipant)
                        publication.track.enable()
                    } else {
                        publication.track.disable()
                        this.setNoVideo(this.room.localParticipant)
                    }
                })
            },
            //---------->>>>>>>>>>>>>>>>>//---------->>>>>>>>>>>>>>>>>
            //Turn ON\OFF - local audio (microphone)
            toggleAudio() {
                this.audioOn = !this.audioOn;
                this.room.localParticipant.audioTracks.forEach(publication => {
                    if (this.audioOn) {
                        publication.track.enable()
                    } else {
                        publication.track.disable()
                    }
                })
            },
            
            //---------->>>>>>>>>>>>>>>>>
            //Set placeholder when video is turnoff
            setNoVideo(participant) {
                const el = this.remoteParticipantElement(participant);
                const div = document.createElement('div');
                div.className = 'no-video';
                el.appendChild(div)
                
            },
            //---------->>>>>>>>>>>>>>>>>//---------->>>>>>>>>>>>>>>>>
            //remove no video placeholder when video is turn on
            removeNoVideo(participant) {
                const el = this.remoteParticipantElement(participant);
                el.querySelector('.no-video').remove();
            },
            
            //---------->>>>>>>>>>>>>>>>>
            // finish call
            finish() {
                this.room.disconnect();
            }
        }
    }
</script>
